# stereo_pan.rb
# -=-=-=-=-=-=-=-=-=-
# Move the camera left or right by half the author's IPD (inter-pupillary distance).
# Good for making stereoscopic renders!
# Copyright (C) 2010 Amos Bieler, all rights reserved.

# License: If you can use it, use it! You can share it, too!
# Just don't try to sell it or claim you made it (i.e. leave the above copyright notice intact).
# Also, if it breaks something, it's your fault for using something *I* wrote in the first place! What were you thinking?! ;)

require 'sketchup'
# require 'rubytoolbar'

module ThreeDee

def self.stereo_pan(dist)
	cam = Sketchup.active_model.active_view.camera
	# cam = Sketchup::Camera.new(camera.eye, camera.target, camera.up)

	# Get a vector perpendicular to Camera#up and Camera#direction, and make it the right length
	perp = cam.direction * cam.up
	perp.length = dist

	# Use the resulting vector to transform Camera#eye and Camera#target
	neweye = cam.eye.offset perp
	newtarg = cam.target.offset perp
	newup = cam.up.clone

	# Debug a little
# 	JF::clearConsole
# 	puts '--Eye-------------------'
# 	puts cam.eye.inspect
# 	puts neweye.inspect
# 	puts '--Target----------------'
# 	puts cam.target.inspect
# 	puts newtarg.inspect
# 	puts '--Up--------------------'
# 	puts cam.up.inspect
# 	puts newup.inspect

	# Use Camera#set to put it all back together
	cam.set(neweye, newtarg, newup)
end

end # module ThreeDee

# =============================================================================

if( not file_loaded?('stereo_pan.rb') )
	UI.menu('Camera').add_item('Move Left') { ThreeDee::stereo_pan(-1.25) }
	UI.menu('Camera').add_item('Move Right') { ThreeDee::stereo_pan(1.25) }

	file_loaded('stereo_pan.rb')
end
